// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <iostream>

#include <anna/core/core.hpp>

#include <anna/io/BinaryReader.hpp>

#include <anna/http/Transport.hpp>
#include <anna/http/Message.hpp>

using namespace std;

int main (int argc, const char** argv)
{
   CommandLine& commandLine (CommandLine::instantiate ());
   io::BinaryReader reader (32 * 1024);
   DataBlock contain (true);
   const DataBlock* block;
   http::Transport transport;
   const http::Message* message;

   Logger::setLevel (Logger::Debug);
   Logger::initialize ("ims_buffer", new TraceWriter ("file.trace", 4096000));
   
   try {
      commandLine.add ("f", CommandLine::Argument::Mandatory, "Nombre del fichero a interpretar");

      commandLine.initialize (argv, argc);
      commandLine.verify ();

      // Lee el contenido del fichero indicado y lo guarda en el buffer 
      reader.open (commandLine.getValue ("f"));
      while ((block = reader.fetch ()) != NULL)
         contain += *block;

      const char* buffer = contain.getData ();
      const int length = contain.getSize ();

      message = transport.externalDecode (buffer, length);

      cout << message->asString () << endl;

      for (http::Message::const_header_iterator ii = message->header_begin (), maxii = message->header_end (); ii != maxii; ii ++) 
         cout << "\t" << http::Message::header (ii)->asString () << endl;
      cout << functions::asString (message->getBody ()) << endl << endl;
   }
   catch (Exception& ex) {
      cout << ex.asString () << endl << endl;
   }
   
   return 0;
}
