// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_comm_Status_hpp
#define anna_comm_Status_hpp

#include <string>

namespace anna {
namespace comm {

/**
   Estados en los que puede estar un proceso desde el punto de vista de las comunicaciones.
   \see Communicator.
*/
class Status {
public:
  enum _v {
    Available = 0, /**< Disponible para recibir peticiones */
    Unavailable = 1, /**< No disponible para recibir peticiones, quizas debido al fallo de un servicio critico */
    Overload = 2 /**< Sobrecargado */
  };

  Status() : a_value(Unavailable) {;}
  Status(const Status& other) : a_value(other.a_value) {;}
  Status(const _v v) : a_value(v) {;}
  Status& operator = (const _v v) throw() { a_value = v; return *this; }
  Status& operator = (const Status& other) throw() { a_value = other.a_value; return *this; }

  bool operator != (const Status& other) const throw() { return a_value != other.a_value;  }
  bool operator != (const Status::_v v) const throw() { return a_value != v ;  }
  bool operator == (const Status& other) const throw() { return a_value == other.a_value;  }
  bool operator == (const Status::_v v) const throw() { return a_value == v ;  }

  _v value() const throw() { return a_value; }

  std::string asString() const throw();

private:
  _v a_value;
};

}
}


#endif

