// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_comm_handler_LocalConnection_hpp
#define anna_comm_handler_LocalConnection_hpp

#include <anna/comm/handler/MetaClientSocket.hpp>

namespace anna {

namespace comm {

class LocalConnection;

namespace handler {

class LocalConnection : public MetaClientSocket {
public:
  LocalConnection(Communicator* communicator) :
    MetaClientSocket(communicator, Handler::Type::LocalConnection),
    a_localConnection(NULL)
  {;}

  void setup(comm::LocalConnection* localConnection) throw() { a_localConnection = localConnection; }

  comm::ClientSocket* getClientSocket() throw();

private:
  comm::LocalConnection* a_localConnection;

  void initialize() throw(RuntimeException);
  void finalize() throw();

  std::string asString() const throw();
  xml::Node* asXML(xml::Node*) const throw();
};

}
}
}

#endif

