// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_comm_handler_RemoteConnection_hpp
#define anna_comm_handler_RemoteConnection_hpp

#include <anna/comm/handler/MetaClientSocket.hpp>

namespace anna {

namespace comm {

class RemoteConnection;

namespace handler {

class RemoteConnection : public MetaClientSocket {
public:
  RemoteConnection(Communicator* communicator) :
    MetaClientSocket(communicator, Handler::Type::RemoteConnection),
    a_remoteConnection(NULL)
  {;}

  void setup(comm::RemoteConnection* remoteConnection) throw() { a_remoteConnection = remoteConnection; }

  comm::ClientSocket* getClientSocket() throw();

private:
  comm::RemoteConnection* a_remoteConnection;

  void initialize() throw(RuntimeException);
  void finalize() throw();
  void clone() throw(RuntimeException);
  std::string asString() const throw();
  xml::Node* asXML(xml::Node*) const throw();
};

}
}
}

#endif

