// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_comm_internal_ConnectionRecover_hpp
#define anna_comm_internal_ConnectionRecover_hpp

#include <anna/core/RuntimeException.hpp>

#include <anna/core/util/Millisecond.hpp>

namespace anna {

namespace xml {
class Node;
}

namespace comm {

class Server;
class Communicator;

class ConnectionRecover {
public:
  bool isRunning() const throw() { return a_isRunning; }

  void annotateFault(Server* server) throw();
//   bool contains (Server* server) const throw ();
//   void erase (Server* server) throw ();
  xml::Node* asXML(xml::Node* parent) const throw(RuntimeException);

private:
  typedef std::vector <Server*> break_container;
  typedef break_container::iterator break_iterator;

  comm::Communicator& a_communicator;
  break_container a_breaks;
  break_iterator a_recovering;
  bool a_isRunning;
  Millisecond a_nextTime;

  ConnectionRecover(Communicator* communicator) : a_communicator(*communicator), a_isRunning(false) {;}
  void tryRecover() throw();

  friend class Communicator;
};

}
}

#endif

