// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_diameter_codec_basetypes_Unsigned32_hpp
#define anna_diameter_codec_basetypes_Unsigned32_hpp


// Local
#include <anna/diameter/codec/basetypes/AvpData.hpp>

#include <anna/config/defines.hpp>


namespace anna {

namespace diameter {

namespace codec {

class Avp;

namespace basetypes {

/**
* Diameter Unsigned32 container
*/
class Unsigned32 : public AvpData {

  U32 a_value;


  // Mandatory for basic diameter type:
  void codeBasic(char* buffer, int &size) throw(anna::RuntimeException);
  void setPrintableString(const char * printableString) throw(anna::RuntimeException);

public:

  virtual ~Unsigned32() {;}

  // Class-specific ////////////////////////////////////////////////////////////////////////////////////
  //
  /**
  * Gets the Unsigned32 value
  *
  * @return Unsigned32 value
  */
  const U32& getValue() const throw() { return a_value; }

  /**
  * Sets the Unsigned32 value
  *
  * @param value Unsigned32 value
  */
  void setValue(const U32& value) throw() { a_value = value; }
  //
  //////////////////////////////////////////////////////////////////////////////////////////////////////


  // gets

  virtual std::string getFormatName() const throw() { return "Unsigned32"; }
  virtual int getSize() const throw() { return 4; }


  // helpers

  std::string asPrintableString() throw(anna::RuntimeException) {
    return anna::functions::asString(a_value);
  }

  std::string asString() throw(anna::RuntimeException) {
    return asPrintableString();
  }


  // sets

  void decode(const char* buffer, const int size) throw(anna::RuntimeException);
};

}
}
}
}

#endif
