// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <anna/core/functions.hpp>

#include <anna/comm/Device.hpp>
#include <anna/comm/functions.hpp>

#include <anna/xml/Node.hpp>
#include <anna/xml/Attribute.hpp>

using namespace std;
using namespace anna;

string comm::Device::asString() const
throw() {
  string result("comm::Device { IP: ");
  result += asString(a_address);
  return result += anna::functions::asString(" | Status: %s }", (a_status == Status::Up) ? "Up" : "Down");
}

xml::Node* comm::Device::asXML(xml::Node* parent) const
throw(RuntimeException) {
  xml::Node* result = parent->createChild("comm.Device");
  result->createAttribute("IP", asString(a_address));
  result->createAttribute("Status", (a_status == Status::Up) ? "Up" : "Down");
  return result;
}

void comm::Device::asAttribute(xml::Node* node) const
throw(RuntimeException) {
  node->createAttribute("IP", asString(a_address));
  node->createAttribute("Status", (a_status == Status::Up) ? "Up" : "Down");
}

std::string comm::Device::asString(const in_addr_t& address)
throw() {
  struct in_addr in;
  in.s_addr = address;
  return string(inet_ntoa(in));
}


