// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


// Local
#include <anna/diameter/codec/basetypes/Float32.hpp>


//------------------------------------------------------------------------------
//--------------------------------------------------------- Float32::codeBasic()
//------------------------------------------------------------------------------
void anna::diameter::codec::basetypes::Float32::codeBasic(char* buffer, int &size) throw(anna::RuntimeException) {
  /*buffer=*/
  anna::comm::functions::codeFloat(buffer, a_value);
  size = getSize();
}


//------------------------------------------------------------------------------
//------------------------------------------------ Float32::setPrintableString()
//------------------------------------------------------------------------------
void anna::diameter::codec::basetypes::Float32::setPrintableString(const char * printableString) throw(anna::RuntimeException) {
  setValue(atof(printableString));
}


//------------------------------------------------------------------------------
//------------------------------------------------------------ Float32::decode()
//------------------------------------------------------------------------------
void anna::diameter::codec::basetypes::Float32::decode(const char* buffer, const int size) throw(anna::RuntimeException) {
  if(!buffer)
    throw anna::RuntimeException("Float32::decode | Null Buffer provided", ANNA_FILE_LOCATION);

  if(size != 4)
    throw anna::RuntimeException("Float32::decode | Buffer length must be 4 bytes", ANNA_FILE_LOCATION);

  a_value = anna::comm::functions::decodeFloat(buffer);
}

