// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <anna/core/tracing/Logger.hpp>
#include <anna/core/tracing/TraceMethod.hpp>
#include <anna/config/defines.hpp>
#include <anna/core/functions.hpp>

#include <libxml/HTMLparser.h>

#include <anna/html/DocumentMemory.hpp>

using namespace std;
using namespace anna;

_xmlDoc* html::DocumentMemory::do_initialize(const char* content)
throw(RuntimeException) {
  LOGMETHOD(TraceMethod tf("html::DocumentMemory", "do_initialize", ANNA_FILE_LOCATION));
  setContent(content);
  _xmlDoc* result = NULL;
  LOGDEBUG(
    string msg("xml::DocumentMemory::do_initialize | Content (char*): ");
    msg += content;
    Logger::debug(msg, ANNA_FILE_LOCATION);
  );
  result = htmlParseDoc((xmlChar*) content, NULL);

  if(result == NULL)
    throw RuntimeException(functions::asString("Error analizando documento HTML:\n%s", content), ANNA_FILE_LOCATION);

  return result;
}

_xmlDoc* html::DocumentMemory::do_initialize(const anna::DataBlock& contain)
throw(RuntimeException) {
  throw RuntimeException("html::DocumentMemory::do_initialize | Not implemented", ANNA_FILE_LOCATION);
  return NULL;
}

